您的位置:首页 > 其它

hdu 1074 Doing Homework 状态压缩dp

2016-01-17 19:13 369 查看

Doing Homework

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 6928    Accepted Submission(s): 3019


[align=left]Problem Description[/align]
Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will reduce
his score of the final test, 1 day for 1 point. And as you know, doing homework always takes a long time. So Ignatius wants you to help him to arrange the order of doing homework to minimize the reduced score.
 

[align=left]Input[/align]
The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.

Each test case start with a positive integer N(1<=N<=15) which indicate the number of homework. Then N lines follow. Each line contains a string S(the subject's name, each string will at most has 100 characters) and two integers D(the deadline of the subject),
C(how many days will it take Ignatius to finish this subject's homework).

Note: All the subject names are given in the alphabet increasing order. So you may process the problem much easier.

 

[align=left]Output[/align]
For each test case, you should output the smallest total reduced score, then give out the order of the subjects, one subject in a line. If there are more than one orders, you should output the alphabet smallest one.

 

[align=left]Sample Input[/align]

2
3
Computer 3 3
English 20 1
Math 3 2
3
Computer 3 3
English 6 3
Math 6 3

 

[align=left]Sample Output[/align]

2
Computer
Math
English
3
Computer
English
Math

Hint
In the second test case, both Computer->English->Math and Computer->Math->English leads to reduce 3 points, but the
word "English" appears earlier than the word "Math", so we choose the first order. That is so-called alphabet order.

 

题意:有n门课,每门课有截止时间和完成所需的时间,如果超过规定时间完成,每超过一天就会扣1分,问怎样安排做作业的顺序才能使得所扣的分最小

思路:因为最多只有15门课程,可以使用二进制来表示所有完成的状况

#include <iostream>
#include <string.h>
#include <algorithm>
#include <stack>
using namespace std;
int num[100005];
struct node
{
char str[105];
int end, time;
}a[20];

struct edge
{
int score;
int day;
int pre, num;// 邻接表用来储存最小扣分的顺序
}dp[33000];
int main()
{
int t, n, i, j;
scanf("%d",&t);
while(t--)
{
scanf("%d", &n);
memset(num, 0, sizeof(num));
for(i=0; i<n; i++)
{
scanf("%s%d%d",a[i].str,&a[i].end, &a[i].time);
}
for(i=1; i<(1<<n); i++)
{
dp[i].score=(1<<30);
for(j=n-1; j>=0; j--)//注意要从大到小,因为题目给的字符串是小到大,求的也是小到大
{
int s=1<<j;
if(s & i)
{
int ans=i-s;//ans表示没有完成j科目
int st=dp[ans].day+a[j].time-a[j].end;
st=max(0, st);
if(st+dp[ans].score<dp[i].score)
{
dp[i].score=st+dp[ans].score;
dp[i].day=dp[ans].day+a[j].time;
dp[i].pre=ans;
dp[i].num=j;
}
}
}
}
int tem=(1<<n)-1;
stack<int>sta;//用栈保存邻接表中的数据
printf("%d\n",dp[tem].score);
while(tem)
{
sta.push(dp[tem].num);
tem=dp[tem].pre;
}
while(!sta.empty())
{
printf("%s\n",a[sta.top()].str);
sta.pop();
}

}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: